let data = [];

function updateData() {
  data = [];
	let numItems = Math.ceil(Math.random() * 10);
	for(let i=0; i<numItems; i++) {
		data.push(Math.random() * 800);
	}
}

function update() {
  // No Transition
	d3.select('div#no-transition svg')
		.selectAll('circle')
		.data(data)
		.join('circle')
		.attr('cy', 50)
		.attr('r', 40)
  	.style('fill', 'red')
		.style('opacity', 0.75)
		.attr('cx',d => d);
  
  // With Transition
  d3.select('div#transition svg')
		.selectAll('circle')
		.data(data, d => d)
		.join('circle')
		.attr('cy', 50)
		.attr('r', 40)
  	.style('fill', 'blue')
		.style('opacity', 0.75)
  	.transition() // NEW
		.attr('cx',d => d);
  
  // Transition with enter, update & exit element
  d3.select('div#with-enter-update-exit svg')
		.selectAll('circle')
		.data(data)
		.join(
    	(enter) => {
      	return enter
        	.append('circle')
					.attr('cy', 50)
					.attr('cx', d => d) // at creation of circle it should be at his position
					.attr('r', 40)
					.style('opacity', 0);
      },
    	(update) => {
        return update;
      },
    	(exit) => {
        return exit
        	.transition()
					.duration(1000)
					.attr('cy', 500)
					.remove();
      }
  	)
  	.transition()
  	.duration(1000)
		.attr('cx', d => d)
  	.style('fill', 'green')
		.style('opacity', 0.75);
}

function updateAll() {
	updateData();
	update();
}

updateAll();